import 'package:mmoo_base_video/generated/json/base/json_field.dart';
import 'package:mmoo_base_video/generated/json/toys_message.g.dart';

@JsonSerializable()
class ToysMessage {
  ToysMessage();

  factory ToysMessage.fromJson(Map<String, dynamic> json) =>
      $ToysMessageFromJson(json);

  Map<String, dynamic> toJson() => $ToysMessageToJson(this);

  //正反旋转true反转
  bool clockWise = false;

  //震动强度0-20
  int vibrate = -1;

  //旋转强度0-20
  int rotate = -1;

  //推荐震动模式
  int preset = -1;

  //是否连接成功
  bool? connection;
}
