import 'package:mmoo_base_video/generated/json/base/json_field.dart';
import 'package:mmoo_base_video/generated/json/video_message.g.dart';

@JsonSerializable()
class VideoMessage {
  VideoMessage();

  factory VideoMessage.fromJson(Map<String, dynamic> json) =>
      $VideoMessageFromJson(json);

  Map<String, dynamic> toJson() => $VideoMessageToJson(this);

  String? userId;

  ///0-拨打，1-取消/拒绝，5-开始计时 6-通知zb没钱了 7-通知zb用户又充值了 8-通话不足2分钟 9-通知对方续费了 20-主播端初始化成功
  int? status;

  ///加入房间到开始计时差
  int? newTime;
}
