import 'package:mmoo_base_video/generated/json/base/json_convert_content.dart';
import 'package:mmoo_base_video/entity/gift_message.dart';

GiftMessageContent $GiftMessageContentFromJson(Map<String, dynamic> json) {
	GiftMessageContent giftMessageContent = GiftMessageContent();
	var giftId = jsonConvert.convert<String>(json['giftId']);
	if (giftId != null) {
		giftMessageContent.giftId = giftId;
	}
	var name = jsonConvert.convert<String>(json['name']);
	if (name != null) {
		giftMessageContent.name = name;
	}
	var pic = jsonConvert.convert<String>(json['pic']);
	if (pic != null) {
		giftMessageContent.pic = pic;
	}
	var url = jsonConvert.convert<String>(json['url']);
	if (url != null) {
		giftMessageContent.url = url;
	}
	var price = jsonConvert.convert<String>(json['price']);
	if (price != null) {
		giftMessageContent.price = price;
	}
	var lottie = jsonConvert.convert<String>(json['lottie']);
	if (lottie != null) {
		giftMessageContent.lottie = lottie;
	}
	return giftMessageContent;
}

Map<String, dynamic> $GiftMessageContentToJson(GiftMessageContent entity) {
	final Map<String, dynamic> data = <String, dynamic>{};
	data['giftId'] = entity.giftId;
	data['name'] = entity.name;
	data['pic'] = entity.pic;
	data['url'] = entity.url;
	data['price'] = entity.price;
	data['lottie'] = entity.lottie;
	return data;
}