import 'package:mmoo_base_video/generated/json/base/json_convert_content.dart';
import 'package:mmoo_base_video/entity/video_message.dart';

VideoMessage $VideoMessageFromJson(Map<String, dynamic> json) {
	VideoMessage videoMessage = VideoMessage();
	var userId = jsonConvert.convert<String>(json['userId']);
	if (userId != null) {
		videoMessage.userId = userId;
	}
	var status = jsonConvert.convert<int>(json['status']);
	if (status != null) {
		videoMessage.status = status;
	}
	var newTime = jsonConvert.convert<int>(json['newTime']);
	if (newTime != null) {
		videoMessage.newTime = newTime;
	}
	return videoMessage;
}

Map<String, dynamic> $VideoMessageToJson(VideoMessage entity) {
	final Map<String, dynamic> data = <String, dynamic>{};
	data['userId'] = entity.userId;
	data['status'] = entity.status;
	data['newTime'] = entity.newTime;
	return data;
}