// import 'dart:async';
// import 'dart:io';
// import 'dart:ui';
//
// import 'package:flutter/cupertino.dart';
// import 'package:flutter/material.dart';
// import 'package:flutter_screenutil/flutter_screenutil.dart';
//
// ///通话ppei页面-demo
// class VideoDemoPage extends StatefulWidget {
//   final String userId;
//   final bool call;
//   final bool match;
//   final String callId;
//   final String channelId;
//   final AnchorEntity anchorEntity;
//
//   VideoDemoPage(this.userId, this.call, this.match, this.callId, this.channelId,
//       this.anchorEntity);
//
//   @override
//   _VideoDemoPageState createState() => _VideoDemoPageState();
// }
//
// class _VideoDemoPageState extends State<VideoDemoPage> with VideoCallDelegate {
//   int status = CommonUtils.pageStatusLoading;
//   bool _load = false;
//   AnchorEntity? anchorEntity; //zb信息
//   late UserProvider userProvider;
//
//   ///通话前计时器
//   Timer? beforeTimer;
//   int beforeRate = 0;
//
//   //-1-未点击拨号(获取到数据显示待接听或拨号界面) 0-链接中 1-正在通话 2-已挂断
//   int callStatus = -1;
//   bool? call; //主动拨打还是被动
//   //网络质量检测
//   bool showNetText = false; //显示网络质量不好的提示
//   String? netText; //显示网络质量不好的提示
//   ///聊天
//   GlobalKey<LiveTextWidgetState> timeKey = GlobalKey();
//   bool? showVideoView = true; //显示界面其他按钮
//   //通话交互
//   GlobalKey<VideoCallWidgetState> videoCallKey = GlobalKey();
//
//   @override
//   void initState() {
//     super.initState();
//     call = widget.call;
//     try {
//       if (widget.match == true) {
//         AppConfig.videoMatchTime =
//             int.parse(BigVideoUtils.instance!.matchEntity!.matchTime!);
//         if (AppConfig.videoMatchTime < AppConfig.VIDEO_DOWN_MATCH)
//           AppConfig.videoMatchTime = AppConfig.VIDEO_DOWN_MATCH;
//       }
//     } catch (e) {
//       AppConfig.printLog(e);
//       AppConfig.videoMatchTime = AppConfig.VIDEO_DOWN_MATCH;
//     }
//   }
//
//   @override
//   void dispose() {
//     BigMediaUtil.instance!.stopPlayAudio();
//     beforeTimer?.cancel();
//     super.dispose();
//   }
//
//   void anchorInfo() {
//     if (anchorEntity!.cost?.isEmpty == false) {
//       checkAnchorInfo(first: true);
//     } else {
//       OtherDao.anchorInfo(widget.userId).then((res) {
//         if (!mounted) {
//           return;
//         }
//         if (res.result) {
//           anchorEntity = res.data;
//           checkAnchorInfo();
//         } else {
//           setState(() => status = CommonUtils.pageStatusError);
//           CommonUtils.showErrorToast(context, res: res);
//         }
//       });
//     }
//   }
//
//   void checkAnchorInfo({bool first = false}) async {
//     startTimer();
//     status = CommonUtils.pageStatusSuccess;
//     callStatus = -1;
//     if (call!) {
//       callStatus = 0;
//       beforeRate = 0;
//       videoCallKey.currentState?.willSendVideo(0);
//     }
//     if (!first) setState(() {});
//   }
//
//   @override
//   Widget build(BuildContext context) {
//     return Consumer<UserProvider>(
//       builder: (_, UserProvider userProvider, __) {
//         this.userProvider = userProvider;
//         if (!_load) {
//           _load = true;
//           anchorEntity = widget.anchorEntity;
//           if (anchorEntity != null) {
//             startTimer();
//             status = CommonUtils.pageStatusSuccess;
//             callStatus = -1;
//           }
//           Future.delayed(const Duration(milliseconds: 500), () {
//             CommonUtils.checkIsCurrent(context, () {
//               if (!Address.gui) {
//                 BigMediaUtil.instance!.startPlayAudio();
//               }
//             });
//           });
//           anchorInfo();
//         }
//         return WillPopScope(
//           onWillPop: () {
//             setHangUp(send: callStatus == -1 && !call!);
//             return Future.value(false);
//           },
//           child: GestureDetector(
//             behavior: HitTestBehavior.opaque,
//             onTap: () => FocusScope.of(context).unfocus(),
//             child: Scaffold(
//               resizeToAvoidBottomInset: false,
//               body: CommonUtils.allBgWidget(
//                 status != CommonUtils.pageStatusSuccess
//                     ? CommonUtils.checkPageStatus(context, status, onTap: () {
//                         if (!mounted) {
//                           return;
//                         }
//                         setState(() => status = CommonUtils.pageStatusLoading);
//                         anchorInfo();
//                       })
//                     : Stack(
//                         children: <Widget>[
//                           VideoCallWidget(
//                               videoCallKey,
//                               NetConfig.AgoraAppKey,
//                               BigVideoUtils.instance!.rtmClient!,
//                               widget.callId,
//                               widget.channelId,
//                               widget.userId,
//                               userProvider.userEntity.name!,
//                               userProvider.userEntity.headImage!,
//                               int.parse(userProvider.userEntity.id!),
//                               call!,
//                               status == CommonUtils.pageStatusSuccess,
//                               delegate: this,
//                               closeWidget: Platform.isAndroid
//                                   ? BackdropFilter(
//                                       filter: ImageFilter.blur(
//                                           sigmaX: 6.0, sigmaY: 6.0),
//                                       child:
//                                           Container(color: Colors.transparent))
//                                   : Container(
//                                       decoration: BoxDecoration(
//                                         gradient: LinearGradient(
//                                           begin: Alignment.topCenter,
//                                           end: Alignment.bottomCenter,
//                                           colors: [
//                                             ConstantColors.bg_top_color,
//                                             ConstantColors.bg_bottom_color,
//                                           ],
//                                         ),
//                                       ),
//                                       child: Column(
//                                         mainAxisAlignment:
//                                             MainAxisAlignment.center,
//                                         children: <Widget>[
//                                           Image.asset(ConstantIcons.VIDEO_CLOSE,
//                                               width: ScreenUtil().setWidth(44),
//                                               height:
//                                                   ScreenUtil().setWidth(44)),
//                                           SizedBox(
//                                               height:
//                                                   ScreenUtil().setWidth(16)),
//                                           Text(S.of(context).strVideoClose,
//                                               style:
//                                                   ConstantText.textSize12Hint,
//                                               textAlign: TextAlign.center)
//                                         ],
//                                       ),
//                                     ),
//                               match: widget.match,
//                               matchEntity: BigVideoUtils.instance!.matchEntity,
//                               videoMatchTime: AppConfig.videoMatchTime,
//                               videoMatchDownTime: AppConfig.VIDEO_DOWN_TIP,
//                               bottomBarHeight: ScreenUtil().bottomBarHeight,
//                               gui: Address.gui),
//                           Visibility(
//                             visible: callStatus == 1 &&
//                                 videoCallKey.currentState?.userUid != null,
//                             child: InkWell(
//                               onTap: NavigatorUtils.debounce(() {
//                                 showVideoView = videoCallKey.currentState
//                                     ?.setShowVideoView();
//                                 setState(() {});
//                               }),
//                               child: Container(),
//                             ),
//                           ),
//                           Visibility(
//                             visible: showVideoView == true &&
//                                 callStatus == 1 &&
//                                 videoCallKey.currentState?.showTime == true,
//                             child: Positioned(
//                               top: ScreenUtil().setWidth(20) +
//                                   ScreenUtil().statusBarHeight,
//                               left: ScreenUtil().setWidth(12),
//                               right: ScreenUtil().setWidth(140),
//                               child: Column(
//                                 crossAxisAlignment: CrossAxisAlignment.start,
//                                 children: <Widget>[
//                                   Row(
//                                     children: [
//                                       IconButton(
//                                         padding: EdgeInsets.all(0),
//                                         icon: Image.asset(
//                                             ConstantIcons.video_close_hand,
//                                             alignment: Alignment.topCenter),
//                                         iconSize: ScreenUtil().setWidth(40),
//                                         onPressed: NavigatorUtils.debounce(() {
//                                           setHangUp(send: true);
//                                         }),
//                                       ),
//                                       Expanded(
//                                         child: Padding(
//                                           padding: EdgeInsets.all(
//                                               ScreenUtil().setWidth(8)),
//                                           child: videoCallKey
//                                                       .currentState?.match15 ==
//                                                   true
//                                               ? Text(anchorEntity!.nickname!,
//                                                   style: ConstantText
//                                                       .textSize22WhiteBold,
//                                                   maxLines: 1,
//                                                   overflow:
//                                                       TextOverflow.ellipsis)
//                                               : Column(
//                                                   crossAxisAlignment:
//                                                       CrossAxisAlignment.start,
//                                                   children: <Widget>[
//                                                     Text(
//                                                         anchorEntity!.nickname!,
//                                                         style: ConstantText
//                                                             .textSize22WhiteBold,
//                                                         maxLines: 1,
//                                                         overflow: TextOverflow
//                                                             .ellipsis),
//                                                     Padding(
//                                                       padding: EdgeInsets.all(
//                                                         ScreenUtil()
//                                                             .setWidth(2),
//                                                       ),
//                                                     ),
//                                                     LiveTextWidget(
//                                                       timeKey,
//                                                       ConstantText
//                                                           .textSize14White,
//                                                       CommonUtils.getTimeStr(
//                                                         DateTime.fromMillisecondsSinceEpoch(
//                                                             (videoCallKey
//                                                                         .currentState
//                                                                         ?.currentRate ??
//                                                                     0) *
//                                                                 1000,
//                                                             isUtc: true),
//                                                       ),
//                                                     ),
//                                                   ],
//                                                 ),
//                                         ),
//                                       ),
//                                     ],
//                                   ),
//                                   Visibility(
//                                     visible: showNetText,
//                                     child: Padding(
//                                       padding: EdgeInsets.all(
//                                           ScreenUtil().setWidth(8)),
//                                       child: Text(netText ?? '',
//                                           style: ConstantText.textSize14White),
//                                     ),
//                                   ),
//                                 ],
//                               ),
//                             ),
//                           ),
//                           Visibility(
//                             visible: !call! &&
//                                 videoCallKey.currentState?.isConnect == null,
//                             child: Center(
//                               child: ButtonWidget(
//                                 '接听',
//                                 ConstantText.textSize14White,
//                                 onPressed: NavigatorUtils.debounce(() {
//                                   videoCallKey.currentState?.userInHouseCheck();
//                                 }),
//                               ),
//                             ),
//                           )
//                         ],
//                       ),
//               ),
//             ),
//           ),
//         );
//       },
//     );
//   }
//
//   void willSendText(String text,
//       {String extra = '', bool call = true, bool tran = false}) async {
//     //被动操作不需要发送消息
//     if (!call) {
//       return;
//     }
//   }
//
//   void normalPop({bool delayed = false, bool popEnd = false}) {
//     BigMediaUtil.instance!.stopPlayAudio();
//     if (delayed) {
//       Future.delayed(const Duration(seconds: 2), () {
//         beforeTimer?.cancel();
//         Navigator.pop(context);
//         if (popEnd &&
//             Address.gui &&
//             videoCallKey.currentState?.match15 == false) {
//           //通话结束页面
//         }
//       });
//     } else {
//       beforeTimer?.cancel();
//       Navigator.pop(context);
//       if (popEnd &&
//           Address.gui &&
//           videoCallKey.currentState?.match15 == false) {
//         //通话结束页面
//       }
//     }
//   }
//
//   void setHangUp({bool net = false, bool send = false, bool close = false}) {
//     if (callStatus == -1 ||
//         callStatus < 1 && beforeRate > AppConfig.VIDEO_MISS - 5) return;
//     if (callStatus == 1) {
//       if (videoCallKey.currentState?.match15 == true &&
//           (videoCallKey.currentState?.currentRate ?? 0) < 5) {
//         //5s才能关闭页面
//       } else {
//         //关闭提示弹窗
//         leaveChannel();
//       }
//     } else if (videoCallKey.currentState?.isSendConnect == true && !close) {
//       //取消匹配
//     } else {
//       if (widget.match != true && (callStatus == 0 || send)) {
//         String type;
//         if (call!) {
//           type = '2';
//         } else {
//           type = '1';
//         }
//         OtherDao.callFail(widget.userId, widget.callId, type,
//             net: net ? '1' : '');
//       }
//       if (net) {
//         if (!call!) {
//           willSendText(S.of(context).strVideoAlertNetErTitle,
//               call: callStatus != -1);
//           videoCallKey.currentState?.willSendVideo(1);
//         }
//       } else if (callStatus == 0 || send) {
//         if (call!) {
//           willSendText(S.of(context).strVideoError0,
//               extra: '3', call: call! || callStatus > -1);
//         } else {
//           willSendText(S.of(context).strVideoError1,
//               extra: '1', call: callStatus != -1);
//         }
//         videoCallKey.currentState?.willSendVideo(1);
//       }
//       normalPop();
//     }
//   }
//
//   //主动判断
//   void showEndView() {
//     videoCallKey.currentState?.leaveChannel();
//     Future.delayed(const Duration(milliseconds: 500), () {
//       if (!mounted) {
//         return;
//       }
//       normalPop(popEnd: true);
//     });
//   }
//
//   //被动判断
//   void leaveChannel() {
//     videoCallKey.currentState?.leaveChannel();
//     if (videoCallKey.currentState?.offline == false) {
//       onRemoteUserLeft(0);
//     }
//   }
//
//   void startTimer() {
//     if (beforeTimer?.isActive == true) return;
//     beforeTimer = Timer.periodic(const Duration(seconds: 1), (timer) {
//       if (!mounted) return;
//       beforeRate++;
//       // Config.printLog('currentRate:$currentRate');
//       if (!call! && Platform.isIOS && callStatus != 1)
//         BigMediaUtil.instance!.startVibration();
//       if (widget.match == true &&
//           videoCallKey.currentState?.isConnect == false) if (callStatus < 1) {
//         if (RechargeUtil.instance!.payPrice != null && callStatus == -1)
//           beforeRate = 0;
//         else if (RechargeUtil.instance!.payPrice == null) {
//           if (beforeRate == AppConfig.VIDEO_MISS) {
//             videoCallKey.currentState?.offline = true;
//             if (callStatus == 0) {
//               videoCallKey.currentState?.willSendVideo(1);
//               if (call! && widget.match != true) {
//                 willSendText(S.of(context).strVideoError2,
//                     extra: 'callStatus0');
//                 OtherDao.callFail(widget.userId, widget.callId, '0');
//               }
//             }
//             normalPop();
//           }
//         }
//       }
//     });
//   }
//
//   void callEnd(dropped) {
//     CommonUtils.showLoadingDialog(context);
//     OtherDao.callEnd(widget.userId, widget.callId,
//             videoCallKey.currentState?.currentRate, dropped)
//         .then((res) {
//       if (!mounted) {
//         return;
//       }
//       Navigator.pop(context);
//       showEndView();
//       if (!res.result) {
//         CommonUtils.showErrorToast(context, res: res);
//       }
//     });
//   }
//
//   @override
//   void onAnalyticsEvent(String name, {Map<String, dynamic>? parameters}) {
//     FirebaseAnalytics().logEvent(name: name, parameters: parameters);
//   }
//
//   @override
//   void onCallStatus(int callStatus) {
//     this.callStatus = callStatus;
//     setState(() {});
//   }
//
//   @override
//   Future onCallStart({bool match = false}) async {
//     BigMediaUtil.instance!.stopPlayAudio();
//     if (match) {
//       return OtherDao.matchSuccess(
//               widget.userId,
//               widget.callId,
//               widget.channelId,
//               BigVideoUtils.instance!.matchEntity!.matchCostUserId)
//           .then((res) {
//         if (!mounted) {
//           return;
//         }
//         if (res.result) {
//           userProvider.userEntity.money = res.data.userBalance;
//           userProvider.notifyListeners();
//           int cost = int.parse(anchorEntity!.cost!);
//           int money = int.parse(userProvider.userEntity.money!);
//           int size = money ~/ cost;
//           if (size == 0) {
//             AppConfig.printLog('匹配通话中费用不足1分钟');
//             videoCallKey.currentState?.matchSoon = true;
//           }
//           beforeTimer?.cancel();
//           if (!mounted) {
//             return;
//           }
//           setState(() {});
//         } else {
//           callStatus = 0;
//           videoCallKey.currentState?.setCallStatus(callStatus);
//           videoCallKey.currentState?.willSendVideo(1);
//           normalPop();
//           CommonUtils.showErrorToast(context, res: res);
//         }
//       });
//     } else {
//       return OtherDao.callStart(widget.userId, call, widget.callId).then((res) {
//         if (!mounted) {
//           return;
//         }
//         if (res.result) {
//           beforeTimer?.cancel();
//           setState(() {});
//         } else {
//           callStatus = 0;
//           videoCallKey.currentState?.setCallStatus(callStatus);
//           videoCallKey.currentState?.willSendVideo(1);
//           normalPop();
//           CommonUtils.showErrorToast(context, res: res);
//         }
//       });
//     }
//   }
//
//   @override
//   void onCalling() {
//     OtherDao.calling(widget.callId).then((res) {
//       if (!mounted) {
//         return;
//       }
//       if (res.result) {
//         if (res.data.cont == '1') {
//           int cost = int.parse(anchorEntity!.cost!);
//           int money = int.parse(userProvider.userEntity.money!);
//           int size = money ~/ cost;
//           if (size == 0)
//             onRemoteUserLeft(2);
//           else
//             onRemoteUserLeft(4);
//         } else {
//           userProvider.userEntity.money = res.data.money;
//           userProvider.notifyListeners();
//           videoCallKey.currentState?.showMoney(false);
//         }
//       } else {
//         leaveChannel();
//         CommonUtils.showErrorToast(context, res: res);
//       }
//     });
//   }
//
//   @override
//   void onCurrentRate(int rate, {bool down = false, bool show = false}) {
//     if (down) {
//     } else if (show) {
//     } else {
//       timeKey.currentState?.onSetState(
//         CommonUtils.getTimeStr(
//           DateTime.fromMillisecondsSinceEpoch(rate * 1000, isUtc: true),
//         ),
//       );
//     }
//   }
//
//   @override
//   void onNormalPop({bool hangup = true, bool? delayed = false}) {
//     if (hangup) {
//       normalPop(delayed: delayed!);
//     } else {
//       setHangUp();
//     }
//   }
//
//   @override
//   void onShowLocalVideo(bool local, {bool check = true}) {
//     if (local) {
//       if (check && status == 2) {
//         CommonUtils.showToast(S.of(context).strVideoErrorTo10);
//         onRemoteUserLeft(4, toast: false);
//       }
//     } else {
//       if (check && status == 2) {
//         CommonUtils.showToast(S.of(context).strVideoErrorOut6);
//         onRemoteUserLeft(4, toast: false);
//       }
//     }
//   }
//
//   @override
//   void onShowMatchWidget({bool recharge = false}) {
//     if (recharge) {
//     } else {}
//   }
//
//   @override
//   int onShowMoney() {
//     int cost = int.parse(anchorEntity!.cost!);
//     int money = int.parse(userProvider.userEntity.money!);
//     return money ~/ cost;
//   }
//
//   @override
//   void onShowNetText(bool? me) {
//     if (me == null) {
//       setState(() {
//         showNetText = false;
//       });
//     } else if (!showNetText) {
//       showNetText = true;
//       if (me) {
//         netText = S.of(context).strVideoNetMe;
//       } else {
//         netText = S.of(context).strVideoNetOther;
//       }
//       setState(() {});
//     }
//   }
//
//   @override
//   void onShowToast(int type) {
//     if (!mounted) {
//       return;
//     }
//     switch (type) {
//       case -1:
//         CommonUtils.showErrorToast(context);
//         break;
//       case 0:
//         CommonUtils.showToast(S.of(context).strVideoNetEr);
//         break;
//       case 1:
//         CommonUtils.showToast(S.of(context).strVideoErrorTo5);
//         break;
//       case 2:
//         CommonUtils.showToast(S.of(context).strVideoErrorTo6);
//         break;
//       case 3:
//         CommonUtils.showToast(S.of(context).strVideoMatchEnd);
//         break;
//       case 4:
//         CommonUtils.showToast(S.of(context).strVideoMatchContinue);
//         break;
//       case 5:
//         CommonUtils.showToast(S.of(context).strVideoErrorTo1);
//         break;
//       default:
//         break;
//     }
//   }
//
//   @override
//   bool onWillCheckSendVideo() {
//     if (!BigVideoUtils.instance!.rtmLogin) {
//       AppConfig.printLog(
//           'rtmLogin: ${BigVideoUtils.instance!.rtmLogin}, rtmLoginOut: ${BigVideoUtils.instance!.rtmLoginOut}');
//       CommonUtils.showToast(S.of(context).strChatImNo);
//       if (BigVideoUtils.instance!.rtmLoginOut) {
//         BigVideoUtils.instance!.rtmLoginOut = false;
//         BigVideoUtils.instance!.rtmLogin = false;
//         BigVideoUtils.instance!.rtmClient = null;
//         BigVideoUtils.instance!.createRtmClient(context,
//             userId: BigVideoUtils.instance!.rtmLoginUserId);
//       }
//       leaveChannel();
//       return false;
//     }
//     return true;
//   }
//
//   @override
//   void onRemoteUserLeft(int dropped, {bool toast = true}) {
//     if (callStatus == 1) {
//       callStatus = 2;
//       videoCallKey.currentState?.setCallStatus(callStatus);
//       videoCallKey.currentState?.showTime = false;
//       if (dropped != 1) {
//         //0-自己挂断//1-对方正常挂断//2-没钱最后一分钟挂断//3-通话过程中对方异常//4-声网回调异常//5-融云时间同步异常
//         call = true;
//         if (dropped == 2 && videoCallKey.currentState?.currentRate != 0) {
//           //2-没钱最后一分钟挂断-calling已经处理了
//           if (toast) {
//             CommonUtils.showToast(S.of(context).strVideoErrorTo8);
//           }
//           willSendText(S.of(context).strVideoError3, extra: '0');
//           showEndView();
//         } else {
//           if (dropped == 3 || dropped == 4 || dropped == 5) {
//             if (toast) {
//               CommonUtils.showToast(S.of(context).strVideoErrorOut5);
//             }
//             willSendText(S.of(context).strVideoError4, extra: '4');
//           } else {
//             willSendText(S.of(context).strVideoError3, extra: '0');
//           }
//           if (videoCallKey.currentState?.match15 == false) {
//             callEnd(dropped);
//           } else {
//             normalPop();
//           }
//         }
//       } else {
//         //通话过程对方挂断
//         if (toast) {
//           CommonUtils.showToast(S.of(context).strVideoErrorOut0);
//         }
//         showEndView();
//       }
//     } else if (callStatus != 2) {
//       if (toast) {
//         CommonUtils.showToast(S.of(context).strVideoErrorTo1);
//       }
//       normalPop();
//     }
//   }
//
//   @override
//   void onVideoSetState() {
//     setState(() {});
//   }
// }
