import 'package:mmoo_base/entity/match_entity.dart';
import 'package:mmoo_base_video/generated/json/base/json_field.dart';
import 'package:mmoo_base_video/generated/json/call_entity.g.dart';

@JsonSerializable()
class CallEntity {
  factory CallEntity.fromJson(Map<String, dynamic> json) =>
      $CallEntityFromJson(json);

  Map<String, dynamic> toJson() => $CallEntityToJson(this);

  String? callId;
  String? userName;
  String? userImage;
  bool? callMatch;
  int? callType;
  int? toyCost;
  String? callCost;
  String? callCostUserId;
  String? callPackage;
  String? matchTime;
  List<MatchCostUser>? matchCostUserId;

  CallEntity(
      {this.callId,
      this.userName,
      this.userImage,
      this.callMatch,
      this.callType,
      this.toyCost,
      this.callCost,
      this.callCostUserId,
      this.callPackage,
      this.matchTime,
      this.matchCostUserId});
}

@JsonSerializable()
class CallLabel {
  CallLabel();

  factory CallLabel.fromJson(Map<String, dynamic> json) =>
      $CallLabelFromJson(json);

  Map<String, dynamic> toJson() => $CallLabelToJson(this);

  String? name;
  String? type;
}
