import 'package:mmoo_base_video/generated/json/base/json_field.dart';
import 'package:mmoo_base_video/generated/json/gift_message.g.dart';

@JsonSerializable()
class GiftMessageContent {
  factory GiftMessageContent.fromJson(Map<String, dynamic> json) =>
      $GiftMessageContentFromJson(json);

  Map<String, dynamic> toJson() => $GiftMessageContentToJson(this);

  String? giftId; //礼物id
  String? name; //礼物名字
  String? pic; //礼物图片
  String? url; //礼物url
  String? price; //礼物价格
  String? lottie; //1为lottie动画，默认空或'0'

  GiftMessageContent(
      {this.giftId, this.name, this.pic, this.url, this.price, this.lottie});
}
